﻿FlagRSPInfo = {
	isMoving = false;
	isExpanded = false;

	FLInfoIsExpanded = false;
	FLInfoIsMoving = false;

	FLInfoBtnIsMoving = false;

	FLInfoX = 520;
	FLInfoY = 300;

	buttonIsBlinking = false;
	postInterval = 1;

	charPerPost = 240;
	maxDescChars = 1600;
	maxDesc = 7;

	maxCharsUnExpanded = 100;

	boxPurgeInterval = 2592000;

	buttonBlinkInterval = 1;
	buttonBlinkState = true;
	buttonBlinkTick = 0;

	targetChanged = false;
};

FlagRSPInfoBoxList = {};


local COLOR_RPTITLE       = "FFFFD100";
local COLOR_CURRENTDESC   = "FFFFD100";
local COLOR_FLAGRP        = "FFFFFF80";
local COLOR_FLAGCHAR      = "FFFFFF80";
local COLOR_INGAMENAME    = "FF909090";

--- Frame functions
--[[ Mouse down actions for InfoBoxButton, InfoBox, FriendlistInfoBox
]]--
function FlagRSPInfo:FrameOnMouseDown(arg1, id)
	if id:GetName() == "FlagRSPInfoBox" then
		if arg1 == "RightButton" then
			self.isMoving = true;
			id:StartMoving();
		elseif arg1 == "LeftButton" then
			if self.isExpanded then
				self.isExpanded = false;
			else
				self.isExpanded = true;
			end
	
			self:displayBox("target");
		end
	elseif id:GetName() == "FRIENDLISTFrameInfoBox" then
		if arg1 == "RightButton" and not FlagRSPConfigure:GetFriendlistEntryBoxLocked() then
			self.FLInfoIsMoving = true;
			id:StartMoving();
		elseif arg1 == "LeftButton" then
			if self.FLInfoIsExpanded then
				self.FLInfoIsExpanded = false;
			else
				self.FLInfoIsExpanded = true;
			end
		end
		FriendlistMain_Update(true);
	elseif id:GetName() == "FlagRSPInfoBoxButton" then
		if arg1 == "RightButton" then
			self.FLInfoBtnIsMoving = true;
			id:StartMoving();
		end
	end
end


--[[ Mouse up actions for InfoBoxButton, InfoBox, FriendlistInfoBox
]]--
function FlagRSPInfo:FrameOnMouseUp(arg1, id)
	if arg1 == "RightButton" then
		id:StopMovingOrSizing();

		if id:GetName() == "FlagRSPInfoBox" then
			if FlagRSPConfigure:GetInfoBoxExpandUpwards() then
				FlagRSPConfigure:SetInfoBoxCoords(FlagRSPInfoBox:GetLeft(), FlagRSPInfoBox:GetBottom());
			else
				FlagRSPConfigure:SetInfoBoxCoords(FlagRSPInfoBox:GetLeft(), FlagRSPInfoBox:GetTop());
			end
	
			self.isMoving = false;
		elseif id:GetName() == "FRIENDLISTFrameInfoBox" then
			FlagRSP:PrintDebug("FL left: " .. FRIENDLISTFrame:GetLeft());
			FlagRSP:PrintDebug("FL top: " .. FRIENDLISTFrame:GetBottom());
			FlagRSP:PrintDebug("Box left: " .. id:GetLeft());
			FlagRSP:PrintDebug("Box top: " .. id:GetTop());

			self.FLInfoX = id:GetLeft() - FRIENDLISTFrame:GetLeft();
			self.FLInfoY = id:GetTop() - FRIENDLISTFrame:GetBottom();

			self.FLInfoIsMoving = false;
		elseif id:GetName() == "FlagRSPInfoBoxButton" then
			local x,y = FlagRSPInfoBoxButton:GetCenter();
		
			FlagRSPConfigure:SetInfoBoxButtonCoords(x, y);

			self.FLInfoBtnIsMoving = false;
			id:StopMovingOrSizing();
		end
	end
end


--[[ Hides InfoBox

FlagRSPInfo:hideBox()

- Hide InfoBox.

]]--
function FlagRSPInfo:hideBox()
	self.isExpanded = false;
	FlagRSPInfoBox:Hide();
end


--[[ Resets the position of the info box

FlagRSPInfo:ResetPosition()

- Resets the position of the info box

]]--
function FlagRSPInfo:ResetPosition()
	FlagRSPData.InfoBoxX = 0;
	FlagRSPData.InfoBoxY = 400;
	FlagRSPData.InfoBoxAlphaBackdrop = 0.3;
	FlagRSPData.displayInfoBox = true;
	FlagRSPData.InfoBoxWidth = 300;
	FlagRSPData.InfoBoxTextSize = 12;
	FlagRSPData.InfoBoxExpandUpwards = true;
	FlagRSPData.InfoBoxLocked = false;
	FlagRSPData.InfoBoxAutoPopUp = true;	
	
	FlagRSPInfo:displayBox("target")
end


--[[ Gets lines for InfoBox

FlagRSPInfo:GetBoxLines(playerID)

- Get lines for InfoBox.

]]--
function FlagRSPInfo:GetBoxLines(playerID)
	local lines = {};

	local nameText = "";
	local notesText = "";
	local descText = "";
	local titleText = "";
	local rpText = "";
	local rp2Text = "";
	local csText = "";

	local targetName, targetRealm = UnitName(playerID);
    local pId = FlagRSP:BuildPlayerID(targetName, targetRealm);

	if UnitExists(playerID) and targetName ~= nil then
		if self.isExpanded then
			notesText = Friendlist:GetNotes(pId);
			descText = self:GetDescription(targetName, playerID);
			descText = self:GetDescription(targetName, playerID);
		else
			notesText = Friendlist:GetNotes(pId);
			
			if ( notesText == nil ) then
				notesText = "";
			end
	
			if string.len(notesText) > self.maxCharsUnExpanded then
				notesText = string.sub(notesText, 1, self.maxCharsUnExpanded) .. "...";
			end
			
			descText = self:GetDescription(targetName, playerID, self.maxCharsUnExpanded);
		end

		nameText = FlagRSPInfo:GetNameTooltipText(playerID);

		if not FlagRSP:GetNameDisp() or TooltipHandler:PlayerIsKnown(targetName) then
			titleText = FlagRSPInfo:GetTitleTooltipText(targetName, targetRealm);
		end

		rpText = TooltipHandler:GetRPTooltipText(targetName, playerID);
		rp2Text = "";
		csText = TooltipHandler:GetCharStatusTooltipText(targetName, playerID);
	else
		nameText = "";
		titleText = "";
		rpText = "";
		rp2Text = "";
		csText = "";
	end

	local lines = {};

	for i=1, 10 do
		lines[i] = "";
	end

	lines[1] = nameText;
	lines[2] = titleText;
	
	lines[3] = rpText;
	lines[4] = rp2Text;
	lines[5] = csText;
    
	if notesText ~= "" and notesText ~= nil then
		lines[6] = "|cFFFFFF00" .. FlagRSP_Locale_InfoBoxNotes .. "\n|r|cFFFFFFFF" .. notesText .. "|r";
	end
	if descText ~= "" and descText ~= nil then
		lines[7] = "|cFFFFFF00" .. FlagRSP_Locale_InfoBoxDesc .. "\n|r|cFFFFFFFF" .. descText .. "|r";
	end

	if UnitExists(playerID) and targetName ~= nil and not UnitIsPlayer(playerID) then
		local r, g, b = TooltipHandler:GetTooltipNameColor(playerID);
		local prefix;
		
		prefix = "|cFF" .. FlagRSPStatic:GetHex(r, g, b);
		lines[1] = prefix ..targetName .. "|r";
		lines[2] = "";
		lines[3] = "";
		lines[4] = "";
		lines[5] = "";
		lines[7] = "";
	end

	return lines;
end


--[[ InfoBox button at targetframe clicked

FlagRSPInfoBoxButton_OnClick(playerID)

- InfoBox button at targetframe clicked.

]]--
function FlagRSPInfoBoxButton_OnClick(playerID)
	local name, realm = UnitName(playerID);
    
    local pId = FlagRSP:BuildPlayerID(name, realm);

	FlagRSPInfo.targetChanged = false;
	
	if FlagRSPInfoBoxButton:GetChecked() == false then
		-- FlagRSPInfoBoxList[name].showBox = false;
		FlagRSPInfoBoxList[pId] = nil;
        
	else
        if FlagRSPInfoBoxList[pId] == nil then
            FlagRSPInfoBoxList[pId] = {};
        end
		FlagRSPInfoBoxList[pId].showBox = true;
        FlagRSPInfoBoxList[pId].seenRev = FlagHandler:GetFlagRev("Desc", name, realm);
        FlagRSPInfoBoxList[pId].timeStamp = time();
	end
	
	FlagRSPInfo:displayBox("target");
end

--[[ Toggles the InfoBoxButton
]]--
function FlagRSPInfo:toggleBox()
	if FlagRSPInfoBoxButton:IsVisible() then
		if FlagRSPInfoBoxButton:GetChecked() == nil then
			FlagRSPInfoBoxButton:SetChecked(true);
			FlagRSPInfoBoxButton_OnClick("target");
		else
			FlagRSPInfoBoxButton:SetChecked(false);
			FlagRSPInfoBoxButton_OnClick("target");
		end
	end
end


--[[ Update timestamp in InfoBox list for object name

FlagRSPInfo:UpdateTimestamp(name)

- Update timestamp in InfoBox list for object name.

]]--
function FlagRSPInfo:UpdateTimestamp(name)
	if ( FlagRSPInfoBoxList == nil ) then
		FlagRSPInfoBoxList = { }
	end

	if FlagRSPInfoBoxList[name] ~= nil then
		FlagRSPInfoBoxList[name].timeStamp = time();
	end
end

--[[ Checks if InfoBoxButton should blink (new desc) 
]]--
function FlagRSPInfo:CheckBlinking(showBoxButtom, playerID) -- TODOSY Blinking currently out of order
    -- local isBlinking = false;
    -- local name = UnitName(playerID);
    -- if ( showBoxButtom == -1) then
        -- isBlinking = true;
        -- local savedRev = FlagHandler:GetDescRev("A", name); -- get revision of desc
        
        -- if savedRef == nil then
            -- savedRef = -1;
        -- end
        -- if (FlagRSPInfoBoxList[name].seenRev == nil
    -- else
        -- isBlinking = false;
        -- self.buttonIsBlinking = false;
        -- FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Up");
    -- end   

    -- return false;    
end

--[[ Sets the blinking images for the button
]]--
function FlagRSPInfo:BlinkButton() -- TODOSY Blinking currently out of order
    -- -- Sets blinking state
    -- print("blink = "..tostring(self.buttonIsBlinking));
    -- if self.buttonIsBlinking then
        -- if GetTime() > self.buttonBlinkTick then
            -- if self.buttonBlinkState then
                -- FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Blink");
                -- self.buttonBlinkState = false;
            -- else
                -- FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Up");
                -- self.buttonBlinkState = true;
            -- end

            -- self.buttonBlinkTick = GetTime() + self.buttonBlinkInterval;
        -- end
    -- end
end

function FlagRSPInfo:RepositionButton()
    -- Sets button position
    if UIParent:IsVisible() then
        if not self.FLInfoBtnIsMoving then
            local compX, compY = FlagRSPConfigure:GetInfoBoxButtonCoords()
            if compX ~= -1 and compY ~= -1 then
                FlagRSPInfoBoxButton:ClearAllPoints();
                FlagRSPInfoBoxButton:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", compX-12, compY+12);
            else
                local anchorFrame = "TargetFrame";
                local x = 0;	-- x anchor for the Blizzard TargetFrame.
                local y = 44;	-- y anchor for the Blizzard TargetFrame.
                if ( ClickCastFrames ) then
                    for key, value in pairs(ClickCastFrames) do
                        if ( key:GetAttribute("unit") == "target" ) then
                            anchorFrame = key:GetName();
                            x = key:GetWidth() / 3;
                            y = key:GetHeight() / 2;
                            break;
                        end
                    end
                end
                
                FlagRSPInfoBoxButton:ClearAllPoints();
                FlagRSPInfoBoxButton:SetPoint("TOPLEFT", anchorFrame, "CENTER", x, y);
            end
        end
    else
        return;
    end	
end

--[[ Check if user wants to see InfoBox

FlagRSPInfo:checkShowBox(playerID)

- Check if user wants to see InfoBox.
    - Returns  1 if box is open, button visible
    - Returns -1 if box is closed, button visible
    - Returns  0 if there is no flag available

]]--
function FlagRSPInfo:checkShowBox(playerID)
	local showBox = 0;
	local name, unitRealm = UnitName(playerID);
    
    local pId = FlagRSP:BuildPlayerID(name, unitRealm)
	
    -- Never shows button
	if ( playerID == nil or strtrim(playerID) == "" ) then
        return 0;
    end
    if ( not FlagHandler:IsSetFlag(name, unitRealm) ) then
        return 0;
    end

    -- Check if show Box    	
	if FlagRSPInfoBoxList[pId] ~= nil then
		if FlagRSPInfoBoxList[pId].showBox then
			showBox = 1;
		else
			showBox = -1;
		end	
    else
        showBox = -1;
	end
    
	return showBox;
end

--[[ Display info box

FlagRSPInfo:displayBox(playerID)

- Display info box.

]]--
function FlagRSPInfo:displayBox(playerID)
	if not FlagRSPConfigure:IsInitialized() or self.isMoving then
		return "";
	end
        
    if not FlagRSPConfigure:GetDisplayInfoBox() then
		self:hideBox();
		FlagRSPInfoBoxButton:Hide();
        
        return "";
    end
    
    local showBoxButton = FlagRSPInfo:checkShowBox(playerID);
    local showBox = false;
    
    if not FlagRSPConfigure:GetAlwaysShowInfoBox() then
        -- Display of InfoBoxButton
        if ( showBoxButton == -1 or showBoxButton == 1 ) then
            FlagRSPInfo:RepositionButton();
            
            -- FlagRSPInfo:CheckBlinking(showBoxButton, playerID)
            -- FlagRSPInfo:BlinkButton();
            
            FlagRSPInfoBoxButton:Raise();
            FlagRSPInfoBoxButton:Show();
            
            if ( showBoxButton == 1 ) then
                showBox = true;
            else
                showBox = false;
            end
            
        else
            FlagRSPInfoBoxButtonNormalTexture:SetTexture("Interface\\Addons\\flagRSP\\artwork\\flagRSPInfoBoxButton_Up");
            FlagRSPInfoBoxButton:Hide();
            showBox = false;
        end
    elseif (FlagRSPConfigure:GetAlwaysShowInfoBox() and (showBoxButton == -1 or showBoxButton == 1) ) then
        showBox = true;
    else
        showBox = false;
    end
    
    -- if ( FlagRSPConfigure:GetAlwaysShowInfoBox() and (showBoxButton == -1 or showBoxButton == 1) ) then
        -- showBox =  true;
    -- end
    
    -- Display of InfoBoxButton
    
    -- Display of InfoBox
    if UnitAffectingCombat("player") or not showBox then 
    
        self:hideBox();
        FlagRSPInfoBoxButton:SetChecked(false);

    else
        local lines = {};
        lines = self:GetBoxLines(playerID);
        local x, y = FlagRSPConfigure:GetInfoBoxCoords();

        FlagRSPInfoBoxButton:SetChecked(true);

        self:UpdateBox("FlagRSPInfoBox", lines, "UIParent", FlagRSPConfigure:GetInfoBoxExpandUpwards(), x, y, FlagRSPConfigure:GetInfoBoxWidth(), showBox);
    
    end
    
end


--[[ Updates the InfoBoxes (target and friendframe)
]]--
function FlagRSPInfo:UpdateBox(boxS,lines,parent,expandDir,x,y,width,showBox)
	local box = getglobal(boxS);
	local height = 0;
	local bText, bText2;

	if box ~= nil then
		if not showBox then
			box:Hide();
		else
			box:Show();
			box:SetWidth(width);
			box:SetAlpha(1);
			box:SetBackdropColor(0,0,0,FlagRSPConfigure:GetInfoBoxAlphaBackdrop());
			height = 22;
			local ii = 1;

			for i=1, 12 do
				bText = getglobal(boxS .. "Text" .. i);

				if i == 1 then
					bText:SetWidth(width - 32);
					bText:SetTextHeight(FlagRSPConfigure:GetInfoBoxTextSize()*1.5);
				else
					bText:SetWidth(width - 22);
					bText:SetTextHeight(FlagRSPConfigure:GetInfoBoxTextSize());
				end

				while ((lines[ii] == "" or lines[ii] == nil) and ii <= 12) do
					ii = ii + 1;
				end
				
				if ii <= 12 then
					bText:SetText(lines[ii]);
					bText:Show();

					height = height + bText:GetHeight();

					ii = ii + 1;
				else
					bText:SetText("");
					bText:SetHeight(0);
					bText:Hide();
				end
			end
	
			box:SetHeight(height);

			box:ClearAllPoints()
			if expandDir then
				box:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", x, y);
				box:SetPoint("TOPLEFT", parent, "BOTTOMLEFT", x, y+height);
			else
				box:SetPoint("TOPLEFT", parent, "BOTTOMLEFT", x, y);
				box:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", x, y-height);
			end
			box:SetWidth(width);
			FlagRSP:PrintDebug("flagRSP: InfoBox width (1)" ..  width);	
			FlagRSP:PrintDebug("flagRSP: InfoBox width (2)" ..  box:GetWidth());	
	
			if GetTime() > FlagRSP.newTickRescaleBox[boxS] then
				box:SetScale(2);
				box:SetScale(1);
				FlagRSP.newTickRescaleBox[boxS] = GetTime() + FlagRSP.rescaleBoxInterval;
			end
		end
	end
end


--[[ Returns the stored description of a character as a string rather than an array

FlagRSPInfo:GetDescription(name, playerID, limit)

-- Returns the stored description of a character as a string rather than an array.

]]--
function FlagRSPInfo:GetDescription(name, playerID, limit)
	if ( limit == nil ) then
		limit = -1;
	end
    
    local pName, pRealm;
    if playerID ~= nil and playerID == "target" then
        pName, pRealm = UnitName(playerID);
    else
        pName, pRealm = strsplit("-",name);
    end
    
    local desc = FlagHandler:GetFlag("Desc", pName, pRealm);
	
	-- Test to make sure we have some value with which to get a description from.
	if ( name ~= "" or name ~= nil or playerID ~= nil or playerID ~= "" ) then
		if ( name == nil or name == "" ) then
			name = UnitName(playerID);
		end
				
		if ( limit > 0 and string.len(desc) > limit ) then
			desc = string.sub(desc, 1, limit) .. "...";
		end
		
		return desc;
	end
end


--[[ Purges the InfoBox list

FlagRSPInfo:PurgeBoxList()

- Purges the InfoBox list.

]]--
function FlagRSPInfo:PurgeBoxList()
	local delTime = time() - self.boxPurgeInterval;
	
	if ( FlagRSPInfoBoxList == nil ) then
		FlagRSPInfoBoxList = { };
	end

	for name, value in pairs(FlagRSPInfoBoxList) do

		if ( value.timeStamp ~= nil ) then
			if value.timeStamp < delTime then
				FlagRSPInfoBoxList[name] = nil;
			end
		end
	end
end


----- MOVED  ---

--[[

FlagRSPInfo:GetNameTooltipText(playerID)

- Returns text for name line in tooltip.

]]--
function FlagRSPInfo:GetNameTooltipText(playerID) -- from TooltipHandler
	local nameText = "";
	local prefix;
   
	local r, g, b = TooltipHandler:GetTooltipNameColor(playerID);
	local colorprefix = "|cFF" .. FlagRSPStatic:GetHex(r, g, b);
	prefix = colorprefix;

	--local name, server = UnitName(playerID);
	local name, server = TooltipHandler:GetCharacterName(playerID, "unit");
    
    local displayedName = "";
	local firstName = TooltipHandler:GetCharacterName(playerID, "first");
   
    local fullname = TooltipHandler:GetFullname( name, server )
    if ( fullname ~= nil and fullname ~= "" and fullname ~= " " ) then-- and name ~= fullname ) then
        prefix = prefix .. fullname .. " ";
    elseif ( fullname == nil and server ~= nil and server ~= "" ) then
        prefix = prefix .. name .. " " .. FlagRSP_Locale_Of .. " " .. server .. " (*)";
    end
	
	if name == nil then
		-- To prevent an error I have not solved yet.
		name = "";
	end    
    
    -- Real player
	if UnitIsPlayer(playerID) then
		local lastName = TooltipHandler:GetCharacterName(playerID, "last");

		if ( (fullname == nil or fullname == "") and lastName ~= nil and lastName ~= "" and lastName ~= " " and name ~= lastName )  then
			if ( string.sub(lastName, 1, 1) == "," ) then
				nameText = prefix .. name .. lastName;
			else
				nameText = prefix .. name .. " " .. lastName;
			end
        elseif ( fullname == nil ) then
            if ( server ~= nil and server ~= "" ) then -- currently always set for foreign servers i guess
                nameText = prefix .. name .. " " .. FlagRSP_Locale_Of .. " " .. server .. " (*)";
            else
                nameText = prefix .. UnitName(playerID);       
            end     
		elseif ( fullname == name ) then
            nameText = prefix;
        else
            -- if ( server ~= nil and server ~= FlagRSP.rName ) then
                -- name = name .. "-" .. server;
            -- end
            nameText = prefix .. " \n|cff909090(" .. name .. ")"; -- player real name
		end
		
		if ( server ~= nil and server ~= "" ) then
            nameText = prefix .. " \n|cff909090(" .. name .. " " .. FlagRSP_Locale_Of .. " " .. server .. ")";
		end

		nameText = nameText .. "|r";
	elseif TooltipHandler:IsPet(playerID) then
		nameText = prefix .. name .. "|r";
	else
		nameText = prefix .. name .. "|r";
	end

	if FlagRSP:GetNameDisp() then
		-- Reset prefix
		prefix = colorprefix;
		if not TooltipHandler:PlayerIsKnown(name) then
			if UnitIsPlayer(playerID) then 
				nameText = prefix .. FlagRSP_Locale_Unknown .. "|r";
                -- Add real player name to the tooltip
                nameText = nameText .. "\n|cff909090(" .. name .. ")"; -- player real name
			elseif TooltipHandler:IsPet(playerID) then
				if playerID == "mouseover" then
					-- if TooltipHandler:PlayerIsKnown(TooltipHandler:GetMouseoverPetOwner()) then
						-- if TooltipHandler:GetMouseoverPetOwner() ~= FlagRSP.pName then	       
							-- nameText = prefix .. "<" .. TooltipHandler:GetMouseoverPetOwnerTooltipText() .. ">|r";
						-- end
					-- else
						nameText = prefix .. FlagRSP_Locale_UnknownPet .. "|r";
					-- end
				else
					nameText = prefix .. FlagRSP_Locale_UnknownPet .. "|r";
				end
			end
		end	    
	end
	
	return nameText;
end


--[[

FlagRSPInfo:GetTitleTooltipText()

- Returns text for title line in tooltip.

]]--
function FlagRSPInfo:GetTitleTooltipText(name, realm) -- from tooltipHandler
	local titleText = "";

	if TooltipHandler:GetRPTitle(name, realm) ~= "" then
		titleText = "|c"..COLOR_RPTITLE .. TooltipHandler:GetRPTitle(name, realm) .. "|r";
	end
   
	return titleText;
end